
/**
*Class GeditGraph.
*
* This class contains methods for graphic drawing needed by Geditor.
*
* @author YuLing Chen
* October, 2000
*/
import java.awt.*;

public class GeditGraph {
public static void chooseColor(Graphics g, int clr)
{
  int redval=clr/1000000;
  int greenval=(clr%1000000)/1000;
  int blueval=(clr%1000);
  g.setColor(new Color(redval,greenval,blueval));
 }
 public static void drawSymb(Graphics g,int X,int Y,int symb,int wid,int dX,int dY)
 {
  switch(symb)
  { case 201: {//oval
              if(X-wid/2<0) 
	      X=X+wid/2;
	      if(Y-wid/2<0)
	      Y=Y+wid/2;
	      if(Y+wid/2>=dY)
	      Y=Y-wid/2;
	      if(X+wid/2>=dX)
	      X=X-wid/2;

               g.fillOval(X-wid/2,Y-wid/2,wid,wid);
                break; 
	      }
    case 202: {//double circle

	    if(X-wid/2<0 )
	    X=X+wid/2;
	    if(Y-wid/2<0)
	    Y=Y+wid/2;
	      if(Y+wid/2>=dY)
	      Y=Y-wid/2;
	      if(X+wid/2>=dX)
	      X=X-wid/2;
           g.drawOval(X-wid/2,Y-wid/2,wid,wid);
           g.drawOval(X-wid/2+wid/3,Y-wid/2+wid/3,wid/2,wid/2); 
	        break; 
	      }
    case 203: {//circle oval
	    if(X-wid/2<0 )
	    X=X+wid/2;
	    if(Y-wid/2<0)
	    Y=Y+wid/2;
	      if(Y+wid/2>=dY)
	      Y=Y-wid/2;
	      if(X+wid/2>=dX)
	      X=X-wid/2;
           g.drawOval(X-wid/2,Y-wid/2,wid,wid);
           g.fillOval(X-wid/2+wid/3,Y-wid/2+wid/3,wid/2,wid/2);break; 
	   }
    case 204:{//solid triangle
	    if(X+wid>dX)
	    X=X-wid; 
	    if(Y+wid>dY)
	    Y=Y-wid;
	    if(X-wid<0) X=X+wid;
	        int[] xval=new int[3];
		int [] yval=new int[3];
		 xval[0]=X;
		 yval[0]=Y;
		 xval[1]=wid+X;
		 yval[1]=wid+Y;
		 xval[2]=X-wid;
		 yval[2]=Y+wid;
	       g.fillPolygon(xval,yval,3);break; 
	       }
    case 205:{//hollow triangle
	    if(X+wid>dX)
	    X=X-wid;
	    if(Y+wid>dY)
	    Y=Y-wid;
	    if(X-wid<0) X=X+wid;
	        int[] xval=new int[3];
		int [] yval=new int[3];
		 xval[0]=X;
		 yval[0]=Y;
		 xval[1]=X+wid;
		 yval[1]=Y+wid;
		 xval[2]=X-wid;
		 yval[2]=Y+wid;
	       g.drawPolygon(xval,yval,3);break; 
	       }
    case 206:{//flag
            int[] xval=new int[3];
	    int[] yval=new int[3];
	    if(X+wid>dX)
	    X=X-wid; 
	    if(Y+wid*2>dY)
	     Y=Y-wid*2;
	        xval[0]=X;
		yval[0]=Y;
		xval[1]=X+wid;
		yval[1]=Y+wid;
		xval[2]=X;
		yval[2]=Y+wid;
		g.fillPolygon(xval,yval,3);
		g.drawLine(X,Y,X,Y+wid*2);
		break;
          }
    case 0: break;
    default:  //same as 201
              {//oval
              if(X-wid/2<0) 
	      X=X+wid/2;
	      if(Y-wid/2<0)
	      Y=Y+wid/2;
               g.fillOval(X-wid/2,Y-wid/2,wid,wid);
                break; 
	      }
  }
 }

 }

