
/**
*Class GeditIdentify.
*
*  Identifying internal frame.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.table.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditIdentify extends JInternalFrame implements TypeConstants,MouseListener,ActionListener
{
private DefaultTableModel model=new DefaultTableModel();
private JTable infotable=new JTable(model);

private JLabel activelayer=new JLabel("Active layer:");
//when the button is pressed, identfying operation is active; otherwise,
//the identifying operation is inactive
private JToggleButton identbutton=new JToggleButton("Identify",true);

private JPanel buttonp=new JPanel();

private Point mousep;
private int[] attrpos;
public String actlayer;//define as public for the Geditor to access
String [][]  data={{"",""}};
//acttype is the type of the current active layer
String acttype;
String [] columname={"Attrs","Values"};
private Geditor gdt;
public boolean active=true;//make it public to let Geditor use it
private Hashtable lgdhtb;
private String[] layersall;

public GeditIdentify(Geditor geditor,String[] allayers,Hashtable legendhtb)
{
   super("Identify Tool",true,true,true,true);
   Dimension d=geditor.getSize();
   int dwid=d.width;
   int dhgt=d.height;
   int wid=dwid/4;
   int hgt=dhgt/3;

   gdt=geditor;
   lgdhtb=legendhtb;
   layersall=allayers; 

   //init this object
   init();

  if(actlayer!=null)
  {
   JScrollPane scp=new JScrollPane(infotable);
   //add the title of each row
   model.addColumn("Attrs");
   model.addColumn("Values");

   identbutton.addActionListener(this);
   buttonp.setLayout(new FlowLayout());
   buttonp.add(identbutton);
   Border etched = BorderFactory.createEtchedBorder();


   geditor.Cdr.addMouseListener(this);

   getContentPane().add("North",activelayer);
   getContentPane().add("Center",scp);
   getContentPane().add("South",buttonp);

   addInternalFrameListener(new Listener(geditor));
   setDefaultCloseOperation( WindowConstants.DISPOSE_ON_CLOSE);
}//end of if(actlayer!=null) 

}

public void mousePressed(MouseEvent e){
if(active)
{
        //get the mouse position
            int x=e.getX();
	    int y=e.getY();
	     if(mousep ==null){
	      mousep =new Point(x,y);
	     }else{
	        mousep.x=x;
	        mousep.y=y;
	         }
            Dimension dim=gdt.Cdr.getSize();
            int dX=dim.width-1,dY=dim.height-1;
	    if(acttype.toUpperCase().compareTo("POINT")==0)
             identPoints(mousep,dX,dY);
	    else if(acttype.toUpperCase().compareTo("POLYGON")==0)
	     identPolygons(mousep,dX,dY);
	     else if(acttype.toUpperCase().compareTo("POLYLINE")==0)
	     identPolylines(mousep,dX,dY);
             showQuery();

 }
}

 public void actionPerformed(ActionEvent evt)
  { Object source=evt.getSource();
       if(source==identbutton)
          {
	      if(identbutton.isSelected())
	         active=true;
	      else
	         active=false;
	    }

  }//end of actionPerformed

  public void mouseReleased(MouseEvent e) {
			         }

  public void mouseEntered(MouseEvent e) {
					      }

  public void mouseExited(MouseEvent e) {}

  public void mouseClicked(MouseEvent e) {}




//initiate the variables of this object 
public void init()
{
 active=true;
 identbutton.setSelected(true);
 lgdhtb=gdt.legendhtb;
 if(lgdhtb!=null)
 for(int i=0;i<layersall.length;i++)
     {
     GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(layersall[i]);
     if(legendarray[0].getActive())
     {actlayer=legendarray[0].name;
     acttype=legendarray[0].type;}
    }
    
    activelayer.setText ("Active Layer: "+actlayer);
    activelayer.setForeground(gdt.messagecolor);
 }

//identify polygons
private  void identPolygons( Point point,int dX,int dY) 
{

    int minX=gdt.minmax[0];
    int maxX=gdt.minmax[1];
    int minY=gdt.minmax[2];
    int maxY=gdt.minmax[3];

    double facX=((double)maxX-(double)minX)/(double)dX;
    double facY=((double)maxY-(double)minY)/(double)dY;
    double factorX,factorY;
    factorX=factorY=Math.max(facX,facY);

    double x=GeditGlobal.LonLat(gdt,point.x,dX,dY,0);
    double y=GeditGlobal.LonLat(gdt,point.y,dX,dY,1);

    String [] selG= GeditSpatial.pointInPolygon(x,y,gdt);

   if(selG!=null)
    if(selG.length>0)
   {
   //first, get the length of data--k
   int k=0;
     for(int j=0;j<gdt.maprel.numattrs;j++)
     {
       if (GeditGlobal.isAddAttr(j,gdt))
       k++;
      }
   data=new String[k][2];
    k=0;
    int pG=gdt.pG;
    for(int i=0;i<gdt.maprel.numtuples;i++)
    {
     String G=((String[])gdt.maprel.data[pG])[i];
     if(G.compareTo(selG[0])==0)
      {
        k=0;
        for(int j=0;j<gdt.maprel.numattrs;j++)
         if (GeditGlobal.isAddAttr(j,gdt))
	  {
           data[k][0]=gdt.maprel.domains[j].name;
	    Object Val=GeditGlobal.calVal(gdt.maprel,i,j);
	    data[k][1]=Val.toString();
	    k++;
	   }
       }
     }//end of for
   }

}

private  void identPolylines( Point point,int dX,int dY) 
{

    int minX=gdt.minmax[0];
    int maxX=gdt.minmax[1];
    int minY=gdt.minmax[2];
    int maxY=gdt.minmax[3];

    double facX=((double)maxX-(double)minX)/(double)dX;
    double facY=((double)maxY-(double)minY)/(double)dY;
    double factorX,factorY;
    factorX=factorY=Math.max(facX,facY);
    double x=GeditGlobal.LonLat(gdt,point.x,dX,dY,0);
    double y=GeditGlobal.LonLat(gdt,point.y,dX,dY,1);
    String [] selG= GeditSpatial.pointOnLine(x,y,gdt);

 if(selG!=null)
  if(selG.length>0)
  {
   //first, get the length of data--k
   int k=0;
     for(int j=0;j<gdt.maprel.numattrs;j++)
     {
       if (GeditGlobal.isAddAttr(j,gdt))
       k++;
      }
   data=new String[k][2];
    k=0;
    int pG=gdt.pG;
    for(int i=0;i<gdt.maprel.numtuples;i++)
    {
    String G=((String[])gdt.maprel.data[pG])[i];
     if(G.compareTo(selG[0])==0)
      { 
        k=0;
        for(int j=0;j<gdt.maprel.numattrs;j++)
         if (GeditGlobal.isAddAttr(j,gdt))
	  {
           data[k][0]=gdt.maprel.domains[j].name;
	    Object Val=GeditGlobal.calVal(gdt.maprel,i,j);
	    data[k][1]=Val.toString();
	    k++;
	   }
       }
     }//end of for
  }


}
//identPoints() check if mouse is near any points
private  void identPoints( Point mousep,int dX,int dY) 
{

    //get minX,minY,maxX,maxY, factorX,factorY

    int minX=gdt.minmax[0];
    int maxX=gdt.minmax[1];
    int minY=gdt.minmax[2];
    int maxY=gdt.minmax[3];

    double facX=((double)maxX-(double)minX)/(double)dX;
    double facY=((double)maxY-(double)minY)/(double)dY;
    double factorX,factorY;
     factorX=factorY=Math.max(facX,facY);

    int difX=(dX/80)/2;
    int difY=(dY/60)/2; 
    int minx=mousep.x-difX;
    int maxx=mousep.x+difX;
    int miny=mousep.y-difY;
    int maxy=mousep.y+difY;

    double xx=GeditGlobal.LonLat(gdt,mousep.x,dX,dY,0);
    double yy=GeditGlobal.LonLat(gdt,mousep.y,dX,dY,1);

    double x1=GeditGlobal.LonLat(gdt,minx,dX,dY,0);
    double x2=GeditGlobal.LonLat(gdt,maxx,dX,dY,0);

    double MINX=0,MAXX=0,MINY=0,MAXY=0;
    if(x1<=x2){ 
      MAXX=x2;  MINX=x1;
     }else{
      MINX=x2;  MAXX=x1;
     }

    double y1=GeditGlobal.LonLat(gdt,miny,dX,dY,1);
    double y2=GeditGlobal.LonLat(gdt,maxy,dX,dY,1);
    if(y1<=y2){
      MINY=y1;  MAXY=y2;
     }else{
      MAXY=y1;  MINY=y2;
     }

   int pX=gdt.pX;
   int pY=gdt.pY;
   int pT=gdt.pT;

   //first, get the length of data--k
   int k=0;
     for(int j=0;j<gdt.maprel.numattrs;j++)
     {
       if (GeditGlobal.isAddAttr(j,gdt))
       k++;
      }

   data=new String[k][2];
    k=0;
   int[] types=gdt.maprel.toTypes(gdt.maprel.domains);
   for(int i=0;i<gdt.maprel.numtuples;i++)
     {
     String T=((String[])gdt.maprel.data[pT])[i];
     if(T.toUpperCase().compareTo("POINT")==0)
     {
       int x=((int[])gdt.maprel.data[pX])[i];
       int y=((int[])gdt.maprel.data[pY])[i];
        k=0;
        if(x<MAXX && x>MINX && y<MAXY && y>MINY)
        for(int j=0;j<gdt.maprel.numattrs;j++)
        {if (GeditGlobal.isAddAttr(j,gdt))
          {
          data[k][0]=gdt.maprel.domains[j].name;
	  Object Val=GeditGlobal.calVal(gdt.maprel,i,j);
	 data[k][1]=Val.toString();
	  k++;
	  }
       }
      }//end of if POINT
}//end of for

}//end of identPoints


private  void showQuery()
{

    Font ft=new Font("Helvetica",Font.PLAIN,16);
    int rownum=model.getRowCount();

    for(int i=0;i<rownum;i++)
       model.removeRow(0);

    for(int i=0;i<data.length;i++)
      model.addRow(data[i]);


}


}//end of class GeditIdentify

class Listener implements InternalFrameListener{
private Geditor gdt;
public Listener(Geditor geditor)
{gdt=geditor;}

public void internalFrameClosed(InternalFrameEvent e) {
gdt.identf.active=false;
gdt.identf=null;

}

 public void internalFrameClosing(InternalFrameEvent e) {
    ;}


 public void internalFrameOpened(InternalFrameEvent e) {
    ;}

 public void internalFrameIconified(InternalFrameEvent e) {
    ;}

public void internalFrameDeiconified(InternalFrameEvent e) {
    ;}

 public void internalFrameActivated(InternalFrameEvent e) {
    ;}

 public void internalFrameDeactivated(InternalFrameEvent e) {
    ;}

}

