
/**
*Class GeditLayerControl.
*
* The dialog of Layer Control.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditLayerControl extends JDialog implements ActionListener{
//Graphic objects
  private String[] layersall;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JCheckBox[] showchbox;
  private ButtonGroup activegroup=new ButtonGroup();
  private JRadioButton[] radiogroup=null;
  private JScrollPane scp=null;

  private boolean ok;
  private Hashtable lgdhtb;
  private boolean[] check;
  private Geditor gdt;
public GeditLayerControl(Geditor parent,String[] allayers,Hashtable legendhtb)
{
 super((JFrame)parent, "Layer Control",true);
 Container contentpane=getContentPane();


 lgdhtb=legendhtb;
 layersall=allayers;
 gdt=parent;
 ok=false;
 //construct the visible showchbox and the active radiogroup
 if(lgdhtb!=null)
 {
 showchbox=new JCheckBox[allayers.length];
 radiogroup=new JRadioButton[allayers.length];
 }
 if(lgdhtb!=null)
 {
  for(int i=0;i<allayers.length;i++)
  {
   radiogroup[i]=new JRadioButton("",false);
   radiogroup[i].addActionListener(this);
   activegroup.add(radiogroup[i]);
   }

 }
 //the top panel
 JPanel p=new JPanel();
 p.setLayout(new BorderLayout());

 JPanel p1=new JPanel();

 p1.setLayout(new GridLayout(0,3));
 JLabel tlayer=new JLabel("Layer");
 p1.add(tlayer);
 JLabel tvis=new  JLabel("Show/Hide");
 JLabel tactive=new JLabel("Active/Inactive");
 p1.add(tvis);
 p1.add(tactive);
 if(lgdhtb!=null)
 {
 check=new boolean[allayers.length];

 for(int i=0;i<check.length;i++)
 {check[i]=false;}

 for(int i=0;i<allayers.length;i++)
 {
 GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(allayers[i]);
   JLabel layername=new JLabel(legendarray[0].name);
   p1.add(layername);

   if(legendarray[0].getVisible())
    check[i]=true;
   else check[i]=false;
   showchbox[i] =new JCheckBox();
   showchbox[i].setSelected(check[i]);
   showchbox[i].addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
	          for(int j=0;j<layersall.length;j++)
		  showchbox[j].setSelected(check[j]);
		}
		});
   p1.add(showchbox[i]);
   boolean chk=false;
   if(legendarray[0].getActive())
    chk=true;
    else chk=false;
    radiogroup[i].setSelected(chk);
    p1.add(radiogroup[i]);

  }
  }
  JPanel buttonpanel=new JPanel();
   cancelbutton.addActionListener(this);
   okbutton.addActionListener(this);
  buttonpanel.add(okbutton);
  buttonpanel.add(cancelbutton);
  p.setLayout(new BorderLayout());
  p.add("Center",p1);
  p.add("South",buttonpanel);
  Border etched = BorderFactory.createEtchedBorder();
  p.setBorder(BorderFactory.createTitledBorder(etched,"Layer Control"));
  scp=new JScrollPane(p);

  contentpane.add("Center",scp);

     Dimension d=parent.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;
     setSize(wid,hgt);
  }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
      else { 
          for(int j=0;j<radiogroup.length;j++)
                { 
		  if(source==radiogroup[j]) //when any radio button clicked
		  {
		   if(!showchbox[j].isSelected())
		   {
		    activegroup.setSelected(null,true);
		   }
		  }
		}
	    }
		
}//end of actionPerformed
public boolean showDialog( Geditor geditor)
{  ok=false;
   show();
   if(ok)
    { 
    //update the legend hashtable
    String activename=null;
     for(int i = 0; i < showchbox.length; i++) 
     {
	 GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(layersall[i]);
         if(showchbox[i].isSelected())
	 {
	  for(int j=0;j<legendarray.length;j++)
	  legendarray[j].setVisible(true);

	 if(radiogroup[i].isSelected())
	 {
	  for(int j=0;j<legendarray.length;j++)
	  legendarray[j].setActive(true);
	  activename=legendarray[0].name;
	  //if the current active layer type is point, enable the symbol
	  //editor menu item
	  if(legendarray[0].type.toUpperCase().compareTo("POINT")!=0)
	   geditor.symbitem.setEnabled(false);
	   else {
	   geditor.symbitem.setEnabled(true);
	   }
	   }
	  else{ 
	    for(int j=0;j<legendarray.length;j++)
	    legendarray[j].setActive(false);
	    }
	 }
	 else
	 { 
	  for(int j=0;j<legendarray.length;j++)
	   { legendarray[j].visible=false;
	      legendarray[j].active=false;
	   }
	  }
	 geditor.legendhtb.remove(layersall[i]);
	 geditor.legendhtb.put(layersall[i],legendarray);
     }//end of for
      //update the active layer of identify internal frame 
      if(gdt.identf!=null) gdt.identf.init();
      //update the active layer map
      if(activename!=null) GeditGlobal.updateActiveMap(gdt,activename);
      }
      return(ok);
    }

}//end of LayerControlDialog class
