
/**
*Class GeditLegendEdit.
*
* The dialog of Legend Editor.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditLegendEdit extends JDialog implements ActionListener,TypeConstants{
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private boolean ok;
  private String actlayer;
  private Hashtable lgdhtb=null;
  private Geditor gdt;
  JLabel layername=null;
  JTextField titlename=null;
  GeditSymbolIcon symbols= null;
  JTextField[] labels= null;
  GeditColorP[] colors= null;

  public GeditLegendEdit(Geditor geditor,String[] allayers)
  {
    super((JFrame)geditor, "Legend Editor",true);
    ok=false;
    gdt=geditor;
    lgdhtb=geditor.legendhtb;

    int num=0;
    for(int i=0;i<allayers.length;i++)
    {
     GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(allayers[i]);
     if(legendarray[0].active==true) //find the active layer
      {
       actlayer=legendarray[0].name;
       num=legendarray.length;//calculate the number of different colors of
       				//this active layer
       break;
      }

    }

    labels=new JTextField[num];
    colors=new GeditColorP[num];

     GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(actlayer);
     layername=new JLabel(actlayer);
     titlename=new JTextField(legendarray[0].title,8);
     int  symbv=legendarray[0].symbol;
     if(legendarray[0].type.toUpperCase().compareTo("POINT")==0)
       symbols=new GeditSymbolIcon(symbv,40,40,40,-25,-10);
      // symbols=new GeditSymbolIcon(symbv,40,40,40,40);
     else
       symbols=new GeditSymbolIcon(0,40,40,40,-25,-10);
       //symbols=new GeditSymbolIcon(0,40,40,40);
     for(int j=0;j<legendarray.length;j++)
      {
        int colorint=(legendarray[j].color);
        colors[j]=new GeditColorP(GeditColor.int2color(colorint));
        labels[j]=new JTextField(legendarray[j].label,8);
      }


     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;

     JPanel buttonp=new JPanel();
     okbutton.addActionListener(this);
     buttonp.add(okbutton);
     cancelbutton.addActionListener(this);
     buttonp.add(cancelbutton);

     JLabel t_layer=new JLabel("Active Layer");
     JLabel t_title=new JLabel("Title");
     JLabel t_color=new JLabel("Color");
     JLabel t_symb=new JLabel("Symbol");
     JLabel t_label=new JLabel("Label");


     JPanel p=new JPanel();
     GridBagLayout gbl=new GridBagLayout();
     Container contentpane=getContentPane();
     p.setLayout(gbl);
     GridBagConstraints constraints=new GridBagConstraints();
     constraints.weightx=100;
     constraints.weighty=100;
     //constraints.fill=GridBagConstraints.BOTH;
     constraints.fill=GridBagConstraints.NONE;
     //constraints.anchor=GridBagConstraints.CENTER;
     constraints.anchor=GridBagConstraints.NORTH;
     GeditGlobal.add(p,t_layer,constraints,0,0,1,1);

     GeditGlobal.add(p,t_title,constraints,1,0,1,1);

     GeditGlobal.add(p,t_color,constraints,2,0,1,1);

     GeditGlobal.add(p,t_symb,constraints,3,0,1,1);

     GeditGlobal.add(p,t_label,constraints,4,0,1,1);


      constraints.insets = new Insets(20,0,0,0);  //top padding;

     GeditGlobal.add(p,layername,constraints,0,1,1,1);


     GeditGlobal.add(p,titlename,constraints,1,1,1,1);

     GeditGlobal.add(p,symbols,constraints,3,1,1,1);

     for(int j=0;j<colors.length;j++)
     {
     constraints.fill=GridBagConstraints.NONE;
     GeditGlobal.add(p,colors[j],constraints,2,j+1,1,1);

    // constraints.fill=GridBagConstraints.BOTH;
     constraints.fill=GridBagConstraints.HORIZONTAL;
     GeditGlobal.add(p,labels[j],constraints,4,j+1,1,1);
      constraints.insets = new Insets(10,0,0,0);  //clear top padding;

     }

     Border etched = BorderFactory.createEtchedBorder();
     p.setBorder(BorderFactory.createTitledBorder(etched,"Legend Editor"));
     JScrollPane scp=new JScrollPane(p);
    contentpane.add("Center",scp);
    contentpane.add("South",buttonp);
     setSize(wid,hgt);
    }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed
public boolean showDialog()
{  ok=false;
     show();
     if(ok)
     updLegend();
     return(ok);

}

private  void updLegend()
{
//update legend hashtable
  GeditLegend[] lgdarray=(GeditLegend[])gdt.legendhtb.get(actlayer);
  GeditLegend[] newlgdarray=new GeditLegend[lgdarray.length];
  String titletext=titlename.getText();
  for(int j=0;j<lgdarray.length;j++)
   {
     //copy the necessary variable from the old legend
     String name=lgdarray[j].name;
     boolean active=lgdarray[j].active;
     boolean visible=lgdarray[j].visible;
     String type=lgdarray[j].type;
     String labelattr=lgdarray[j].labelattr;
     int symbol=lgdarray[j].symbol;
     int color=lgdarray[j].color;
     //only change the titles and labels
     String title=titletext; 
     String labeltext=labels[j].getText();
     String label=labeltext;
     newlgdarray[j]=new GeditLegend(name,title,color,symbol,labelattr,label,visible,active,type);

    }
  gdt.legendhtb.remove(actlayer);
  gdt.legendhtb.put(actlayer,newlgdarray);
}
}


