
/* JJT: 0.2.2 */
import java.io.*;
import java.net.*; //added by Zongyan Aug 2002
public class SimpleNode implements Node, java.io.Serializable,Constants, TypeConstants
{
  protected Node parent;
  protected java.util.Vector children;
  protected String identifier;
  protected Object info;

  protected int type;
  protected int opcode;
  protected String name;
  protected int bits;      //bits for order or existance of options
  protected java.util.Vector list;
  protected int active;   // active = 1/0, for event handler, on/off weizhong
  protected String url; //  added by Zongyan ,July 21 2002


  public SimpleNode(String id) {
	identifier = id;
	url = null;
	name = null;
  }    
  
  /**
   * method that dump the sub parser tree to a text file 
   * 
   * @author Zongyan Wang July 19, 2002
   */
 
  public void dump( PrintWriter out ) throws IOException {
	   String infoType;
	   int numChildren;
	   if (info instanceof String) infoType="String";
	   else if (info instanceof Integer) infoType="Integer";
	   else if (info instanceof Float) infoType="Float";
	   else if (info instanceof Double) infoType="Double";
	   else if (info instanceof Short) infoType="Short";
	   else if (info instanceof Long) infoType="Long";
	   else if (info instanceof Byte) infoType="Byte";
	   else infoType="null";
	   numChildren = (children == null) ? 0 : children.size();
	   out.println( identifier + "|" + url + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
	   if (children != null) {
	     for (java.util.Enumeration e = children.elements();
	     e.hasMoreElements();) {
         SimpleNode n = (SimpleNode)e.nextElement();
         n.dump( out );
	     }
	   }
	
   }  
    /** dump and convert url
     * @author Zongyan Wang -- Aug 2002
     */
  public void dump( PrintWriter out,String URL ,Environment env) throws IOException,InterpretError {
	   String infoType,path;
	   int numChildren,pos;
	   boolean flag = false;
	  
	   if (info instanceof String) infoType="String";
	   else if (info instanceof Integer) infoType="Integer";
	   else if (info instanceof Float) infoType="Float";
	   else if (info instanceof Double) infoType="Double";
	   else if (info instanceof Short) infoType="Short";
	   else if (info instanceof Long) infoType="Long";
	   else if (info instanceof Byte) infoType="Byte";
	   else infoType="null";
	   
	   numChildren = (children == null) ? 0 : children.size();
	   if (type == ALDATP_DECLARATION){
		   url = null;
		   type = OP_DECLARATION;
		    out.println( identifier + "|" + url + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
	   }
	   else if (type == OP_ALDATP & url!= null ) {
		   if( url.trim().equals(URL.trim())) {
			flag = true ;
		   }
	      else if ( !url.equals(URL)){
		   pos = URL.indexOf("aldatp://");
		   path = System.getProperty("user.dir");
	       if (pos <0 ) // local down
			   url = "aldatp://" + aldatpUtility.getHostname()  + path.substring(path.indexOf("public_aldatp") + 13) + url;
		   
		   if (url.startsWith("aldatp://localhost")) // local up
			   url = "aldatp://" + aldatpUtility.getHostname() + url.substring(18);
		   
		   out.println( identifier + "|" + url + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
		   flag = true;
		  }
	   }
	   else if (type == OP_IDENTIFIER) {
		  Relation rl = env.lookupRel(name, true);
		  
		  if (url == null & rl!= null){
		  path = System.getProperty("user.dir");
		  if( path.indexOf("public_aldatp") >= 0 ){
		  if (path.endsWith("public_aldatp"))
	    	  url = "aldatp://" + aldatpUtility.getHostname() +"/"  ;
		  else
			 url = "aldatp://" + aldatpUtility.getHostname() +"/" + path.substring(path.indexOf("public_aldatp") + 14) + System.getProperty("file.separator");
		  }
		  else url = "aldatProtect://" + aldatpUtility.getHostname() +"/" + path;   
			out.println( "IDENTIFIER" + "|" + url + "|" + OP_ALDATP + "|" + OP_ALDATP + "|" + null + "|" + 0 + "|" 
					+ infoType + "|" + info + "|" + 1);
		   }
			url = null;
			out.println( identifier + "|" + url + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
	   }
	   else
	   out.println( identifier + "|" + url + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
	   if (children != null & flag == true) {
	     for (java.util.Enumeration e = children.elements();
	     e.hasMoreElements();) {
         SimpleNode n = (SimpleNode)e.nextElement();
         n.dump( out );
	     }
		  flag = false;
	   }
	    else if (children != null & flag == false) {
	     for (java.util.Enumeration e = children.elements();
	     e.hasMoreElements();) {
         SimpleNode n = (SimpleNode)e.nextElement();
         n.dump( out,URL ,env);
	     }
	   }
	
   }  
  
  
   
   public SimpleNode updateChangeDump( PrintWriter out ) throws IOException {
	   String infoType;
	   int numChildren;
	   SimpleNode result=null;
	   
	   if (info instanceof String) infoType="String";
	   else if (info instanceof Integer) infoType="Integer";
	   else if (info instanceof Float) infoType="Float";
	   else if (info instanceof Double) infoType="Double";
	   else if (info instanceof Short) infoType="Short";
	   else if (info instanceof Long) infoType="Long";
	   else if (info instanceof Byte) infoType="Byte";
	   else infoType="null";
	   numChildren = (children == null) ? 0 : children.size();
	   if(type == ALDATP_UPDATE) type = OP_UPDATE;
	   out.println( identifier + "|" + null + "|" + type + "|" + opcode + "|" + name + "|" + bits + "|" 
					+ infoType + "|" + info + "|" + numChildren);
	   if (type == OP_USING){
		  result = (SimpleNode) jjtGetChild(0);
		 }
	   if (children != null & type != OP_USING) {
	     for (java.util.Enumeration e = children.elements();
	     e.hasMoreElements();) {
         SimpleNode n = (SimpleNode)e.nextElement();
         result = n.updateChangeDump( out );
	     }
	   }
	 return result;
   }  
  /* Override this method if you want to customize how the node dumps
	 out its children. */
  public void dump(String prefix) {
	System.out.println(toString(prefix) + ":" + type + ":" + opcode +
	":" + name + ":" + bits);
	if (children != null) {
	  for (java.util.Enumeration e = children.elements();
	  e.hasMoreElements();) {
   SimpleNode n = (SimpleNode)e.nextElement();
   n.dump(prefix + " ");
	  }
	}
  }    
  public Object getInfo() { return info; }    
  public Object getObject() { return info; }    
  public boolean isBitSet(int pos) {
	return ((bits >>> pos & 0x01) != 0) ? true : false;
  }    
  public void jjtAddChild(Node n) {
	if (children == null) {
	  children = new java.util.Vector();
	}
	children.addElement(n);
  }    
  public void jjtAddChildAtHead(Node n) {
	if (children == null) {
	  children = new java.util.Vector();
	}
	children.insertElementAt(n,0);
  }    
  public void jjtClose() {
	if (children != null) {
	  children.trimToSize();
	}
  }    
  public static Node jjtCreate(String id) {
	return new SimpleNode(id);
  }    
  public static SimpleNode jjtCreateNode(String id, int type,
	int opcode, String name){
	SimpleNode node = new SimpleNode(id);
	node.name = name;
	node.type = type;
	node.opcode = opcode;

	return node;
  }    
  public SimpleNode jjtDeepDuplicate()
  {  SimpleNode result = new SimpleNode(identifier);
	 result.type = type;
	 result.opcode = opcode;
	 result.url = url;
	 result.name = name;
	 result.bits = bits;
	 result.info = info;
	 //REVISIT: result.list = ?? Do we use this field??
	 if (children != null)
	 {  for(int i=0; i<children.size(); i++)
		{  SimpleNode ch = (SimpleNode) children.elementAt(i);
		   SimpleNode chDup = ch.jjtDeepDuplicate();
		   result.jjtAddChild(chDup);
		   chDup.jjtSetParent(result);
		}
	 }
	 return result;
  }    
  /**
   * Duplicate a new node.
   */
  public SimpleNode jjtDuplicate(){
	 SimpleNode node = new SimpleNode(identifier);

	 node.parent = parent;
	 if(children != null)
		node.children = (java.util.Vector)children.clone();
	 node.info = info;
	 node.type = type;
	 node.opcode = opcode;
	 node.url = url;
	 if(name == null)
   node.name = "";
	 else
		node.name = new String(name);
//System.out.println("setting node.bits to " + bits);
	 node.bits = bits;
	 if(list != null)
		node.list = (java.util.Vector)list.clone();

	 return node;
  }    
  public Node jjtGetChild(int i) {
	return (Node)children.elementAt(i);
  }    
  public int jjtGetNumChildren() {
	return (children == null) ? 0 : children.size();
  }    
  public Node jjtGetParent() { 
	return parent; 
  }    
  public void jjtOpen() {
  }    
  // remove and return child indexed by i 
  // if no such child, return null
  public Node jjtRemoveChild(int i) {
	if (children == null || children.size() <= i) {
	  return null;
	} else {
	  Node n = (Node) children.elementAt(i);
	  children.removeElementAt(i);
	  return n; 
	}
  }    
  /**
   * Replace _this_ node with node 'n'.
   */
  public void jjtReplace(SimpleNode n){
	 parent = n.parent;
	 identifier = new String(n.identifier);
	 if(n.children != null)
		children = (java.util.Vector)n.children.clone();
	 info = n.info;
	 type = n.type;
	 opcode = n.opcode;
	 url = n.url;
	 if(n.name == null)
   name = "";
	 else
		name = new String(n.name);
	 bits = n.bits;
	 if(n.list != null)
		list = (java.util.Vector)n.list.clone();
  }    
  
  
  /**
   * replace a child with the one indexed as i in this node.
   * if no such child, do nothing.
   */
  public void jjtReplaceChild(int i, Node node) {
	if (children == null || children.size() <= i) {
	   // do nothing but return.
	}else{
	  children.setElementAt(node, i);
	}
  }    
  public void jjtSetParent(Node n) { 
	parent = n; 
  }    
  public void set(int t, int op) {
	type = t; opcode = op;
  }    
  public void set(int t, int op, String s) {
	type = t; opcode = op; name = s;
  } 
  //start Zongyan's addition, July 2002
   public void set(String u,int t, int op) {
	type = t; opcode = op; url = u;
  }  
   public void set(String u, int t, int op, String s) {
	type = t; opcode = op; name = s; url = u;
  } 
  // end Zongyan's addition, July 2002
  public void setBit(int pos) {
	bits |= 0x01 << pos;
  }    
  /* These two methods provide a very simple mechanism for attaching
	 arbitrary data to the node. */

  public void setInfo(Object i) { info = i; }    
  public void setObject(java.lang.Object o) {
	info = o;
  }    
  /* You can override these two methods in subclasses of SimpleNode to
	 customize the way the node appears when the tree is dumped.  If
	 your output uses more than one line you should override
	 toString(String), otherwise overriding toString() is probably all
	 you need to do. */

  public String toString() { return identifier; }    
  public String toString(String prefix) { return prefix + toString(); }    
}
