/**
 * Aldatp Server Handler
 *
 * @author Zongyan Wang
 * 
 * July 29 2002 --
 *
 */
import java.io.*;
import java.net.*;
import java.util.*;


class aldatpHandler extends Thread implements Constants, TypeConstants
{
  private Socket socket8888;
  private DataInputStream inSocket;
  private PrintWriter outSocket;
  private String fileSeparator;
 
  public aldatpHandler(Socket s) { socket8888= s; }
  
  public static long interpretTime;
  public static Environment env;   
  public static CompTable comptable;
  public static ExprTable exprtable;
 
  private SimpleNode node;
  private Relation rel = null;
  private String path;
  private String rspCode = "200 OK" ;
  private String url;
  private int port,pos;
  private boolean find = false;
  private  String fromClient,contentType,URL,fromServer,res,userName, userHome;
 
  
  
  public void run()
  { 
	 
	try
    { 
	  
	  Global.active_threads ++;  
	  inSocket= new DataInputStream(socket8888.getInputStream());
      outSocket = new PrintWriter(socket8888.getOutputStream(), true);
	  
      // initial input phase: parse request 
	   if (!Global.permit_start) {
		  outSocket.println("RESPONSE_CODE : Warning! Server is shuting down, please try later" );
		  outSocket.println("CONTENT_TYPE : no");
		  Global.active_threads --;
		  return;
	  }
	 
			 
	  File outputFile = new File("_tmp_aldatp_tmpFile.txt");
      FileOutputStream os = new FileOutputStream(outputFile);
      PrintWriter outFile = new PrintWriter(os);
	 
		try{
			StringTokenizer st = new StringTokenizer(inSocket.readLine(), ":");
			if (st.nextToken().indexOf("CONTENT_TYPE")<0 )
	             aldatpError("should start with CONTENT_TYPE" );
	        contentType = st.nextToken().trim();
			//if (Debug) Global.println("handler -- CONTENT_TYPE:" + contentType);
			
			//start contentType is "ParserTree"
			if( contentType.equals("ParserTree")  ) {
			    
			
		        while ((fromClient = inSocket.readLine()) != null) {
			        if (fromClient.equals( "END" )) break;
				    outFile.println( fromClient);
                }
			} 
			
			// start contentType is "allocatePort"
			else if ( contentType.equals("allocatePort")) {
				userName = inSocket.readLine();
				userHome = inSocket.readLine();
				path = inSocket.readLine();
				find = false;
				
				 if (Global.availablePort.empty() )
					 aldatpUtility.checkport();
				 if (!Global.userHomes.containsKey(userName))
					 Global.userHomes.put(userName,userHome);
				 if (Global.services.containsKey(path + System.getProperty("file.separator")))
					 outSocket.println("RESPONSE_CODE :  JRelix is running on this directory" );
				 else if (!Global.availablePort.empty() ){
					 String port = Global.availablePort.pop().toString();
					 if (Debug){
						 Global.println(" port number: allocated" + port);
						 System.out.println(path +System.getProperty("file.separator"));
					 }
					outSocket.println("RESPONSE_CODE : OK" );
					outSocket.println(port);
				} else
					outSocket.println("RESPONSE_CODE : NO available port" );
				    Global.active_threads --;
				return; 
			} 
			
			// start contentType is "confirmPort"
			else if ( contentType.equals("confirmPort")) {
				path = inSocket.readLine();
				String port = inSocket.readLine();
				Global.services.put(path + System.getProperty("file.separator"),port);
				 Global.active_threads --;
				return; 
			}
			
			// start contentType is "enquirePort"
			
			else if ( contentType.equals("enquireProtectedPort") || contentType.equals("enquireLocalPort") || contentType.equals("enquireRemotePort") ) {	
				url = inSocket.readLine();
				String URL = url;
				if ( contentType.equals("enquireRemotePort")){
				    path = System.getProperty("user.dir");
					if(!url.startsWith("~")) {
					   url  = path + System.getProperty("file.separator") + url;
					}
					else {
					    pos = url.indexOf(System.getProperty("file.separator"));
						userName = url.substring(1,pos);
						if (Global.userHomes.containsKey(userName)){
							userHome = Global.userHomes.get(userName).toString();
						    url  = userHome + System.getProperty("file.separator") + "public_aldatp" + System.getProperty("file.separator") + url.substring(pos+1);
						} else
							// no info about the user's home directory yet
							url  = url.substring(0,pos+1) + "public_aldatp" + System.getProperty("file.separator") + url.substring(pos+1);
						
					}
				}
				if(Debug) System.out.println("url in enquirePort:" + url);
							find = false;
				 
					 if (Global.services.containsKey(url) ){
						 port = Integer.parseInt(Global.services.get(url).toString());
						 outSocket.println("RESPONSE_CODE : OK");
						 outSocket.println(port);
						 find = true;
					 } 
                 				 				 if (find == false){ // the sub-server is not on, start it
	             try
                 {  
		              File outTmp = new File("_tmp_aldatp_sh");
                      FileOutputStream ot = new FileOutputStream(outTmp);
                      PrintWriter tmpFile = new PrintWriter(ot);
					  tmpFile.println("cd " + url);
					  tmpFile.println("java JRelixBack & ");
					  tmpFile.close();
					  
					  Runtime rt = Runtime.getRuntime();
					  try {
					//	  Process pr = rt.exec("cd " + url);
				    //    pr = rt.exec("java JRelix");
						  Process pr = rt.exec("sh _tmp_aldatp_sh");
					  }
					  catch(Exception e) {
						   Global.processThrowable(e); 
		                   //throwMsg(e);
				      }  
                 }
                 catch(IOException e) {
					  Global.processThrowable(e); 
		              //throwMsg(e);
	             }
	
				 sleep(2000);
				 // try to get the user's home directory again				 
				 if (url.startsWith("~")) {					 
				 if (Global.userHomes.containsKey(userName)){
					     userHome = Global.userHomes.get(userName).toString();
					     url  = userHome + System.getProperty("file.separator") + "public_aldatp" + System.getProperty("file.separator") + URL.substring(pos+1);
					}
				 }
				 					 find = false;
					  if (Global.services.containsKey(url) ){
						 port = Integer.parseInt(Global.services.get(url).toString());
						 outSocket.println("RESPONSE_CODE : start server");
						 outSocket.println(port);
						 find = true;
					 } 
					 if (find == false)
					 outSocket.println("RESPONSE_CODE : server not available");
							
				 }	
				 Global.active_threads --;
				return; 

			} 
			// start contentType is "checkPort"
			else if ( contentType.equals("checkPort")) {
				path = System.getProperty("user.dir");
				//if (Debug) Global.println("Handler path: " + path);
				outSocket.println("ALDATP_PATH:" + path );  //^_^
				Global.active_threads --;
				return;
			} 
			
			
			// start contentType is "getRelName"
			
			else if ( contentType.equals("getRelName")) {
				Interpreter interpreter = new Interpreter();
				String name = interpreter.nextTempName();
				outSocket.println(name );  //^_^
				Global.active_threads --;
				return;
			} 
			
			// start contentType is "putRel"
			else if ( contentType.equals("putRel")){
				String relname =  inSocket.readLine();
				if(Debug) System.out.println("putRel:" + relname);
				env = Global.environment;
				Relation rel =  aldatpClient.buildRel(inSocket,env);
				if (Debug) {
					System.out.println("rel.name: " + rel.name);
					System.out.println("relname: " + relname);
				}
				String tmp = rel.name;	
				rel.name = relname;
				env.put(rel);
				aldatpUtility.copyfile(tmp, relname);
				Global.active_threads --;
				return;
			}
			
			// start contentType is "quitServer"
			else if ( contentType.equals("quitServer")) { //should check the server is not processing other requests?
				Global.permit_start = false;
				Global.active_threads --;
				Global.exit(0);
			}
			
			// start contentType is "quit"
			else if ( contentType.equals("quit")) {
				path = inSocket.readLine();
                 if (Global.services.containsKey(path + System.getProperty("file.separator"))) {
					     String tmp = Global.services.get(path + System.getProperty("file.separator")).toString();
						 Global.services.remove(path + System.getProperty("file.separator"));
						 Global.availablePort.push(tmp);
				 } 
				 Global.active_threads --;
				 return; 
			} 
		}
		 catch (IOException e) {
			rspCode = "500 internal server error";
		    Global.processThrowable(e);
			//throwMsg(e);
			return;
        }
	     outFile.close(); 

      // processing phase: 		
      processParserTree();		
      Global.active_threads --;		
      if(Debug) System.out.println("threads:" + Global.active_threads);
	
	}
    catch (Exception e)
    { 
		rspCode = "500 internal server error";
		Global.processThrowable(e);
		//throwMsg(e);
		return;
    }
  } // run
  
  
  private void processParserTree()
  {
      Interpreter interpreter = new Interpreter();
	  env = Global.environment;
      exprtable = Global.exprtable;
	  comptable = Global.comptable;
	  
				 
	  // interpret  -- remote request or internal updown request
	
	     String tmpname = interpreter.nextTempName();
		 
	     try {
			 
		 node = aldatpUtility.getRootNode();	 
		 PermissionCheck(node);
		 if (Debug) interpreter.traverse(node);
		 if( node.type == OP_ALDATP) 
		       node = (SimpleNode) node.jjtGetChild(0); //remove redundant node :type=OP_ALDATP
		 
         switch(node.type) 
		 {
		 case OP_ASSIGNMENT:
		 case OP_UPDATE:
		 case OP_COMMAND :
         case OP_STATEMENT :
         case OP_DECLARATION :
			 interpretTime = interpreter.interpret(node, env);
			 break;
			 
		 default:
			 if (Debug) Global.println("handler -- type: " + node.type );
			 rel = interpreter.evaluateTLExpression( node,tmpname, new Hashtable(), env);
			 break;
			  }
		 }
			 catch (InterpretError e) {
				 rspCode = e.getMessage();
				 Global.processThrowable(e); 
				 //throwMsg(e);
	     }   catch (Exception e) {
				rspCode = e.getMessage();
	            Global.processThrowable(e);				//throwMsg(e);
		 }
			 	  	//  sendResponse();
		
		
			outSocket.println("RESPONSE_CODE :" + rspCode);
			if(Debug) Global.println("handler -- return rspCode : " + rspCode);
			if (rel != null){
				outSocket.println("CONTENT_TYPE :Rel");
				aldatpUtility.outputRel(null,rel,outSocket,env);
			}
			else{
				if(Debug) Global.println("handler -- CONTENT_TYPE :noRel");
				outSocket.println("CONTENT_TYPE :noRel");
			}
  
  }
  
 
  private  void aldatpError(String msg) //return rsp_code ^_^
  { 
	rspCode = "301 bad protocol " + msg;
	return;	 
    
  } 
  
 
public void throwMsg (Throwable e) {  //throw message to client
  String path = System.getProperty("user.dir");
  outSocket.println("CONTENT_TYPE: errorMsg");
  outSocket.println(" // Start message at " + path);
  e.printStackTrace(outSocket);
  outSocket.println(" // End message at " + path);
  outSocket.println("END");
}

 public void PermissionCheck(SimpleNode node) throws InterpretError {	 	 
	 if(node.type == OP_ASSIGNMENT || node.type == OP_UPDATE || 	   (node.type == OP_DECLARATION && node.opcode == OP_VIEW))  {  //check the left hand data writeable
		 SimpleNode nn = (SimpleNode) node.jjtGetChild(0);
		 File fdest = new File(nn.name);
	     if (fdest.exists()){			 if (!aldatpUtility.canWrite(fdest.getName())){
				 throw new InterpretError("Permission denied to write " + fdest.getName());		     }		 }else {
	     File fcompdest = new File(nn.name + ".comp");
	     if (fcompdest.exists()){			 if (!aldatpUtility.canWrite(fcompdest.getName())){
				 throw new InterpretError("Permission denied to write " + fcompdest.getName());		     }		 }		 }
	 }
			 	 
	 if (node.opcode == OP_IDENTIFIER & node.type == OP_IDENTIFIER) {  // check the data readable	     
	 File fdest = new File(node.name);
	     if (fdest.exists()){			 if (!aldatpUtility.canRead(fdest.getName())){
				 throw new InterpretError("Permission denied to read " + fdest.getName());		      }		 }else {
		 File fcompdest = new File(node.name + ".comp");
	     if (fcompdest.exists()){			 if (!aldatpUtility.canRead(fcompdest.getName())){
				 throw new InterpretError("Permission denied to read " + fcompdest.getName());		      }		}  	   }
	 }	 	  for(int i = 0; i < node.jjtGetNumChildren(); i++) {
      PermissionCheck((SimpleNode) node.jjtGetChild(i));
      }  }   


} // class aldatpHandler
