/**
 * This class contains utilities for aldatp.
 * 
 * @author : Zongyan Wang
 * 
 */
import java.io.*;
import java.util.*;
import java.net.*;

class aldatpUtility  implements TypeConstants, Constants
{
	
 

/**
   * method that  rebuild a parser tree 
   * input: text file containing the data of the parser tree
   *        each  line refers to one node of the tree.
   *        identifier + ":" + type + ":" + opcode + ":" + name + ":" + bits + ":" 
					+ infoType + ":" + info + ":" + numChildren
   * output: the root node of the parser tree
   * @author Zongyan Wang    July 19, 2002
   */
   public static SimpleNode jjtRebuild( DataInputStream in ) throws IOException
  {  
	  
	  String node,identifier,name,infoType,url;
	  int numChildren;	  int pos, nextpos;
		  
	 node = in.readLine(); 
	 pos = node.indexOf("|");
	 identifier = node.substring(0,pos);
	
	 SimpleNode result = new SimpleNode(identifier);
	 
	 nextpos = node.indexOf("|",pos+1);
	 url = node.substring(pos+1,nextpos) ;
	 if ( ! url.equals("null") ) result.url = url; 
	 
	 pos=nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 result.type = Integer.parseInt(node.substring(pos+1,nextpos));
	 
	 pos = nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 result.opcode = Integer.parseInt(node.substring(pos+1,nextpos));
	 
	 pos = nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 name = node.substring(pos+1,nextpos);
	 if ( ! name.equals( "null") ) result.name = name;

	 pos = nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 result.bits = Integer.parseInt(node.substring(pos+1,nextpos));
	 
	 pos = nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 infoType = node.substring(pos+1,nextpos);
	 	 
	 pos = nextpos;
	 nextpos = node.indexOf("|",pos+1);
	 if ( infoType.equals("String") ) 
		 result.info = node.substring(pos+1,nextpos);
	 else if (infoType.equals("Integer"))
		 result.info = Integer.valueOf(node.substring(pos+1,nextpos));
	 else if (infoType.equals("Long"))
	     result.info = Long.valueOf(node.substring(pos+1,nextpos));
	 else if (infoType.equals("Short"))
	     result.info = Short.valueOf(node.substring(pos+1,nextpos));
	 else if (infoType.equals("Double"))
	     result.info = Double.valueOf(node.substring(pos+1,nextpos));
	 else if (infoType.equals("Float"))
	     result.info = Float.valueOf(node.substring(pos+1,nextpos));
	 //else if (infoType.equals("Byte"))
	 //   result.info = Byte.valueOf(node.substring(pos+1,nextpos));
	 
	 pos = nextpos;
	 numChildren = Integer.parseInt(node.substring(pos+1));
	
	 	
	 if (numChildren != 0)
	 {  for(int i=0; i<numChildren; i++)
		{  SimpleNode ch = jjtRebuild( in );
		   result.jjtAddChild(ch);
		   ch.jjtSetParent(result);
		}
	 }
	 return result;
	 
  }   
   
  // Zongyan July 19 , 2002
   public  static SimpleNode getRootNode(  ) throws IOException
  {  	   SimpleNode node;
	  		 File inputFile = new File("_tmp_aldatp_tmpFile.txt");
         DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));	
	   node = jjtRebuild(inFile);       inFile.close();
	   return node;
   } 
   

 // Zongyan July  2002
  public static  void copyfile (String source, String target)
  {
	File inputFile = new File(source);
	File outputFile = new File(target);
    try {
        FileReader in = new FileReader(inputFile);
        FileWriter out = new FileWriter(outputFile);
        int c;

        while ((c = in.read()) != -1)
           out.write(c);
		  

        in.close();
        out.close();
	}
	catch (IOException e) {
		Global.processThrowable(e);
	}     
   }
  
 // Zongyan Aug 2002
  public static  String getHostname ()
  {
	  String hostname="localhost";
	  Runtime rt = Runtime.getRuntime();
           try {                            
                 Process pr = rt.exec("hostname");    
                 DataInputStream is = new DataInputStream(pr.getInputStream());
                 hostname = is.readLine();
           }
            catch(IOException e) {
                   System.out.println(e.getMessage());
            }
	  return hostname;
  }
  
   // Zongyan Aug 2002
   public static void  outputRel(Hashtable surrogates, Relation rel, PrintWriter outSocket,Environment env)
  {
	  String Fname = null;
	  String fromClient;
	  String rspCode;
	  int pos;
	  byte[] b;
	  String id = null;
	  Stack tuple = new Stack();
	  int num;
	  
	  try{
		
	  if (surrogates != null) { 
		 Fname = rel.name;	     File inputFile = new File(Fname);
         DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));		 		     
         while ((fromClient = inFile.readLine()) != null) {
				 b = fromClient.getBytes();
				 for (pos=0; pos< b.length;pos++){
					 if (b[pos] == 6) {
					  id = fromClient.substring(0,pos);
					  break;
					 }
			    } 
	           if(!surrogates.containsKey(id)) continue;
		     	   tuple.push( fromClient);			 }
		 inFile.close();
	  }
		if (surrogates != null) num = tuple.size();
		else num = rel.numtuples;
		
      outSocket.println(rel.name + "|" + rel.rvc + "|" + num + "|" + rel.numattrs +
						  "|" + rel.numsortattrs);
	 if(Debug) System.out.println(rel.name + "|" + rel.rvc + "|" + num + "|" + rel.numattrs +
						  "|" + rel.numsortattrs);	  for (int i = 0; i < rel.domains.length; i++){
		 outSocket.println( rel.domains[i].name +"|" + rel.domains[i].type );
	 if(Debug)	 System.out.println( rel.domains[i].name +"|" + rel.domains[i].type );		 
		 if(rel.domains[i].type == IDLIST & !rel.domains[i].name.equals(".id"))
		 {
			 if (Debug) System.out.println("lookup :." + rel.domains[i].name);
			 Relation nrel = env.lookupRel("." + rel.domains[i].name, true);
			 if (nrel == null)
			    throw new InterpretError("Relation ." + nrel.name + " not found");
			 
			 //get all the surrugates of the attribute
			 if (rel.rvc == 17) {
				 outputRel(null, nrel,outSocket,env);
			 }
			 else {
			 Hashtable Parent_Sur = new Hashtable();
			 Fname = rel.name;	         File inputFile = new File(Fname);
             DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));					 
             while ((fromClient = inFile.readLine()) != null) {
				 int j = 0, init = 0;
				 b = fromClient.getBytes();
				 for (pos=0; pos< b.length;pos++){
				   if (b[pos] == 6) {
					 if (j == i) {
					     id = fromClient.substring(init,pos);
						 Parent_Sur.put(id,id);
						 break;
					 }
					 j++;
					 init = pos+1;
				   }
				}			 }
		
	        inFile.close();
			outputRel(Parent_Sur, nrel,outSocket,env); // can't ship the whole .Authors ^_^
			 }			
		 }	  }
	 if (rel.rvc == 17) {//computation
	     rel.tree.dump(outSocket);
		 outSocket.println("END");
	 }				
	 if (rel.rvc == 17) 	 {   Fname = rel.name + ".comp";	     File inputFile = new File(Fname);
         DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));
	     while ((fromClient = inFile.readLine()) != null) {
	        outSocket.println( fromClient);	     }
		 inFile.close();	 }	 else {		 Fname = rel.name;	     File inputFile = new File(Fname);		 
         DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));
				 if (surrogates == null) {
			 while ((fromClient = inFile.readLine()) != null) {
	            outSocket.println( fromClient);
			    if(Debug) System.out.println("output: " + fromClient);
			 }	     }
		 else {
			 while(!tuple.empty()){
				 fromClient = tuple.pop().toString();		       	   outSocket.println( fromClient);
				    if(Debug) System.out.println("output: " + fromClient);			 }
		 }
		 inFile.close();	 }
		outSocket.println("END");
	 }
	  catch (FileNotFoundException e) {
		  outSocket.println("END");
	  }
	  catch (IOException e){
			Global.processThrowable(e);
			//throwMsg(e);
	  }
	   catch (InterpretError e) {
				 rspCode = e.getMessage();
				 Global.processThrowable(e); 
				 //throwMsg(e);
	  }
	 	
  }
   
   
   //Zongyan Sep 2002
 public static String getmode(String fname) {
	 int bit1 = 0;
	 int bit2 = 0;
	 int bit3 = 0;
	 
	 Runtime rt = Runtime.getRuntime();
	 try {
		 Process pr = rt.exec("ls -l " + fname);
		 DataInputStream is = new DataInputStream(pr.getInputStream());
		 String res = is.readLine();
		
		 if ( res.substring(1,2).equals("r") ) bit1 = 4;
		 if ( res.substring(2,3).equals("w") ) bit1 = bit1 + 2;
		 if ( res.substring(3,4).equals("x") ) bit1 = bit1 + 1;
		 if ( res.substring(4,5).equals("r") ) bit2 = 4;
		 if ( res.substring(5,6).equals("w") ) bit2 = bit2 + 2;
		 if ( res.substring(6,7).equals("x") ) bit2 = bit2 + 1;
		 if ( res.substring(7,8).equals("r") ) bit3 = 4;
		 if ( res.substring(8,9).equals("w") ) bit3 = bit3 + 2;
		 if ( res.substring(9,10).equals("x") ) bit3 = bit3 + 1;
			
	 }
	  catch(IOException e) {
		  System.out.println(e.getMessage());
	 } 
	 String mode = 	 Integer.toString(bit1) + Integer.toString(bit2) + Integer.toString(bit3) ;
	 return mode;
	
 }
 
   //Zongyan Sep 2002
 public static boolean canRead(String fname) {
	 Runtime rt = Runtime.getRuntime();
	 try {
		 if (fname.startsWith("_temp")) return true;
		 Process pr = rt.exec("ls -l " + fname);
		 DataInputStream is = new DataInputStream(pr.getInputStream());
		 String res = is.readLine();
		 if ( !res.substring(7,8).equals("r") )
			 return false;
	 }
	  catch(IOException e) {
		  System.out.println(e.getMessage());
	 } 
	 return true;
 }
 
   //Zongyan Sep 2002
 public static boolean canWrite(String fname) {
	 Runtime rt = Runtime.getRuntime();
	 try {
		 if (fname.startsWith("_temp")) return true;
		 Process pr = rt.exec("ls -l " + fname);
		 DataInputStream is = new DataInputStream(pr.getInputStream());
		 String res = is.readLine();
		 if ( !res.substring(8,9).equals("w") )
			 return false;
	 }
	  catch(IOException e) {
		  System.out.println(e.getMessage());
	 } 
	return true;
 }

  //Zongyan Sep 2002
  public static void checkport()
  { 
	  
  int port;
  Socket Socket = null;
  PrintWriter outSocket = null;
  BufferedReader inSocket = null;
  String record,path;
   
    Global.availablePort = new Stack();
	Global.services = new Hashtable();
	  try
       { 
		 File inputFile = new File(".ports");
         DataInputStream inFile = new DataInputStream(new FileInputStream (inputFile));	    
		 
		 while ((record = inFile.readLine()) != null) {
				 port = Integer.parseInt(record.trim());
			try {
            Socket = new Socket("localhost",port);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
            inSocket = new BufferedReader(new InputStreamReader(Socket.getInputStream()));
			outSocket.println("CONTENT_TYPE :checkPort");
			StringTokenizer st = new StringTokenizer(inSocket.readLine(), ":");
			if (st.nextToken().indexOf("ALDATP_PATH")<0 )
	             continue;
	        path = st.nextToken().trim();
			
            }
            catch (Exception e) { //suppose the port is not used ^_^
				//if (e.getMessage().trim().equals("Connection refused"))
				   Global.availablePort.push( record.trim());
				continue;
			}
			 Global.services.put(path + System.getProperty("file.separator"),record.trim());
         }
			
		 inFile.close();
       }
      catch(Exception e) {
		  Global.processThrowable(e);
	  }
	}
 
}

